uniform vec4 color_ambient;
uniform vec3 light_source;

varying vec4 vPosition;
varying vec3 N;
varying vec3 v;    
void main (void)
{
//    vec3 L = normalize(gl_LightSource[0].position.xyz - v);

    vec3 L = normalize(light_source - vPosition.xyz);
    vec3 E = normalize(-v); // we are in Eye Coordinates, so EyePos is (0,0,0)
    vec3 R = normalize(-reflect(L,N));

    // calculate Ambient Term:
    vec4 Iamb = color_ambient;

    //calculate Diffuse Term:
    vec4 Idiff = vec4(0.0, 0.8, 0.0, 1.0) * max(dot(N,L), 0.0); // swiatlo
    Idiff = clamp(Idiff, 0.0, 1.0);


    // calculate Specular Term:
    vec4 Ispec = gl_FrontLightProduct[0].specular * pow(max(dot(R,E),0.0),0.3*gl_FrontMaterial.shininess);
    Ispec = clamp(Ispec, 0.0, 1.0);


    // write Total Color:
    gl_FragColor = Iamb + Idiff; // + Ispec;

    //gl_FragColor = vec4(1.0, 0.0, 0.0, 0.5);

/*
    gl_FragColor = color_ambient;

    vec4 color_bottom = vec4(0.3, 0.3, 0.3, 1.0);

    if(vPosition.y < 0.0){
        gl_FragColor = vec4(color_bottom.x, color_bottom.y, color_bottom.z, 0.9);
    }

    if(vPosition.z > 0.98){
       gl_FragColor = vec4(0.8, 0.4, 0.0, 0.9);
    }

    if(vPosition.z < 0.02){
       gl_FragColor = vec4(0.0, 0.4, 0.8, 0.9);
    }
*/

}