uniform vec4 color_ambient;
uniform vec3 light_sorce;

varying vec3 N;
varying vec3 v;    
void main (void)
{
//    vec3 L = normalize(gl_LightSource[0].position.xyz - v);
    vec3 L = normalize(vec3(50.0, 50.0, 100.0) - v);
    vec3 E = normalize(-v); // we are in Eye Coordinates, so EyePos is (0,0,0)
    vec3 R = normalize(-reflect(L,N));

    //calculate Ambient Term:
    vec4 Iamb =  vec4(0.1 + color_ambient.x, 0.1 + color_ambient.y, 0.1 + color_ambient.z, 1.0);

    //calculate Diffuse Term:
    vec4 Idiff = gl_FrontLightProduct[0].diffuse * max(dot(N,L), 0.0);
    Idiff = clamp(Idiff, 0.0, 1.0);


    // calculate Specular Term:
    vec4 Ispec = gl_FrontLightProduct[0].specular
                * pow(max(dot(R,E),0.0),0.3*gl_FrontMaterial.shininess);
    Ispec = clamp(Ispec, 0.0, 1.0);
    // write Total Color:
    gl_FragColor = gl_FrontLightModelProduct.sceneColor + Iamb + Idiff + Ispec;
}