#version 330

uniform mat4 p3d_ModelViewProjectionMatrix;
uniform mat4 p3d_ModelViewMatrix;
uniform mat3 p3d_NormalMatrix;

in vec4 vertex;
in vec3 normal;
in vec2 p3d_MultiTexCoord0;

out vec3 vpos;
out vec3 norm;
out vec4 shad[3];

out vec4 vPosition;
out vec2 texcoord;

uniform struct {
  vec4 position;
  vec4 diffuse;
  vec4 specular;
  vec3 attenuation;
  vec3 spotDirection;
  float spotCosCutoff;
  float spotExponent;
  sampler2DShadow shadowMap;
  mat4 shadowViewMatrix;
} p3d_LightSource[3];

void main() {
  gl_Position = p3d_ModelViewProjectionMatrix * vertex;
  vpos = vec3(p3d_ModelViewMatrix * vertex);
  norm = normalize(p3d_NormalMatrix * normal);
  shad[0] = p3d_LightSource[0].shadowViewMatrix * vertex;
  shad[1] = p3d_LightSource[1].shadowViewMatrix * vertex;
  shad[2] = p3d_LightSource[2].shadowViewMatrix * vertex;

  texcoord = p3d_MultiTexCoord0;
  vPosition = vertex;
}